(* EPITA SPE 2009/2010       *)
(* Control 1 - Novembre 2009 *)
(* question10.ml             *)

module Q = Question10

let rec print_t_list =
  function
      Q.Nil -> Format.printf " {}"
    | Q.Cons {Q.value=h;Q.next=t} ->
	Format.printf "@;{@[<b 1>@;value= %02d;@;next=" h;
	print_t_list t;
	Format.printf "@]@;}"

let main () =
  begin
    let q = new Test_frame.qIntList 10 100 in
      q#beginParse;
      q#init;
      let l = q#makeList in
	Test_frame.printListpref string_of_int l;
	Format.printf "@[<b 0>from_list l = ";
	print_t_list (Q.from_list l);
	Format.printf "@]@.";
  end

let _ = main ()
