(* EPITA SPE 2009/2010       *)
(* Control 1 - Novembre 2009 *)
(* question11.ml - Test      *)

module Q = Question11

let print_int_array a =
  let len = Array.length a in
    begin
      Format.printf "@[<v 0>-%s@;|" (String.make (5 * len) '-');
      Array.iter (Format.printf " %02d |") a;
      Format.printf "@;-%s@;@]" (String.make (5 * len) '-');
    end

let (fill_from_list: 'a array -> int -> 'a list -> unit) =
  fun a pos l -> Q.fill_from_list a pos l

let main () =
  begin
    let q = new Test_frame.qIntList 11 100 in
      q#beginParse;
      q#init;
      let l = q#makeList in
      let a = Array.make q#getSize (-1) in
	Test_frame.printListpref string_of_int l;
	Format.printf "@.fill_from_list a 2 l@.";
	fill_from_list a 0 l;
	print_int_array a;
	Format.printf "@.";
	let l = q#makeList in
	let a = Array.make (q#getSize + 2) (-1) in
	  Test_frame.printListpref string_of_int l;
	  Format.printf "@.fill_from_list a 2 l@.";
	  fill_from_list a 2 l;
	  print_int_array a;
	  Format.printf "@.";
  end

let _ = main ()
